import { defineComponent as M, ref as v, onMounted as L, markRaw as j, watch as x, unref as w, openBlock as b, createElementBlock as S, computed as T, nextTick as q, shallowRef as K, getCurrentInstance as Q, onBeforeUnmount as X, normalizeClass as Y, normalizeStyle as ee, createBlock as te, resolveDynamicComponent as ne, mergeProps as oe } from "vue";
import "codemirror/lib/codemirror.css";
import "codemirror/addon/fold/foldgutter.css";
import "codemirror/addon/fold/foldcode.js";
import "codemirror/addon/fold/foldgutter.js";
import "codemirror/addon/fold/brace-fold.js";
import "codemirror/addon/selection/active-line.js";
import R from "codemirror";
import "codemirror/addon/merge/merge.css";
import "codemirror/addon/merge/merge.js";
import re from "diff-match-patch";
import "codemirror/addon/mode/simple.js";
!window.CodeMirror && (window.CodeMirror = R);
const _ = window.CodeMirror || R, se = M({
  name: "DefaultMode",
  props: {
    name: {
      type: String,
      default: `cm-textarea-${+/* @__PURE__ */ new Date()}`
    },
    value: {
      type: String,
      default: ""
    },
    content: {
      type: String,
      default: ""
    },
    options: {
      type: Object,
      default: () => ({})
    },
    cminstance: {
      type: Object,
      default: () => null
    },
    placeholder: {
      type: String,
      default: ""
    }
  },
  emits: {
    ready: (e) => e,
    "update:cminstance": (e) => e
  },
  setup(e, { emit: n }) {
    const r = v(), t = v(null), o = () => {
      t.value = j(_.fromTextArea(r.value, e.options)), n("update:cminstance", t.value);
      const s = x(
        () => e.cminstance,
        (l) => {
          var m;
          l && ((m = e.cminstance) == null || m.setValue(e.value || e.content)), n("ready", w(t)), s == null || s();
        },
        { deep: !0 }
      );
    };
    return L(() => {
      o();
    }), {
      textarea: r,
      initialize: o
    };
  }
}), I = (e, n) => {
  const r = e.__vccOpts || e;
  for (const [t, o] of n)
    r[t] = o;
  return r;
}, ae = ["name", "placeholder"];
function le(e, n, r, t, o, s) {
  return b(), S("textarea", {
    ref: "textarea",
    name: e.$props.name,
    placeholder: e.$props.placeholder
  }, null, 8, ae);
}
const F = /* @__PURE__ */ I(se, [["render", le]]);
window.diff_match_patch = re;
window.DIFF_DELETE = -1;
window.DIFF_INSERT = 1;
window.DIFF_EQUAL = 0;
const ie = M({
  name: "MergeMode",
  props: {
    options: {
      type: Object,
      default: () => ({})
    },
    cminstance: {
      type: Object,
      default: () => ({})
    }
  },
  emits: ["update:cminstance", "ready"],
  setup(e, { emit: n }) {
    const r = v(), t = v(), o = () => {
      r.value = j(
        _.MergeView(t.value, e.options)
      ), n("update:cminstance", r.value), n("ready", r);
    };
    return L(() => {
      o();
    }), {
      mergeView: t,
      initialize: o
    };
  }
}), ce = { ref: "mergeView" };
function ue(e, n, r, t, o, s) {
  return b(), S("div", ce, null, 512);
}
const de = /* @__PURE__ */ I(ie, [["render", ue]]);
var pe = /* @__PURE__ */ ((e) => (e.info = "info", e.warning = "warning", e.error = "error", e))(pe || {});
function me() {
  const e = /* @__PURE__ */ new Date(), n = e.getHours() < 10 ? `0${e.getHours()}` : e.getHours(), r = e.getMinutes() < 10 ? `0${e.getMinutes()}` : e.getMinutes(), t = e.getSeconds() < 10 ? `0${e.getSeconds()}` : e.getSeconds();
  return `${n}:${r}:${t}`;
}
function Fe(e) {
  return `#link#${JSON.stringify(e)}#link#`;
}
function ge(e) {
  const n = /#link#(.+)#link#/g, r = [];
  let t;
  for (t = n.exec(e); t; ) {
    const o = document.createElement("a"), s = JSON.parse(t[1]), l = Object.entries(s);
    for (const [m, u] of l)
      o.setAttribute(m, u);
    o.className = "editor_custom_link", o.innerHTML = "logDownload", r.push({
      start: t.index,
      end: t.index + t[0].length,
      node: o
    }), t = n.exec(e);
  }
  return r;
}
function He(e = "", n = "info") {
  return `#log<${n}>log#${e}#log<${n}>log#`;
}
function fe(e) {
  const n = [];
  function r() {
    const t = /#log<(\w*)>log#((.|\r\n|\n)*?)#log<(\w*)>log#/g;
    let o;
    for (o = t.exec(e); o; ) {
      const l = o[0].replace(/\r\n/g, `
`).split(`
`), u = o[2].replace(/\r\n/g, `
`).split(`
`), d = document.createElement("span"), c = o[1];
      d.className = `c-editor--log__${c}`;
      let p = 0;
      for (let i = 0; i < l.length; i++) {
        const f = l[i], k = u[i], y = d.cloneNode(!1);
        y.innerText = k, n.push({
          start: o.index + p,
          end: o.index + p + f.length,
          node: y
        }), p = p + f.length + 1;
      }
      o = t.exec(e);
    }
  }
  return r(), n;
}
function Re(e, n) {
  return `[${me()}] <${n}> ${e}`;
}
function ze(e, n, r) {
  const o = new Array(Math.max(n || 15, 5)).join(r || "=");
  return `${o}${e}${o}`;
}
const C = [
  {
    regex: /(\[.*?\])([ \t]*)(<error>[ \t])(.+)/,
    token: ["tag", "", "error.strong", "error.strong"],
    sol: !0
    // next: "error",
  },
  {
    regex: /(\[.*?\])([ \t]*)(<info>)(.+)(.?)/,
    token: ["tag", "", "bracket", "bracket", "hr"],
    sol: !0
    // next: "info",
  },
  {
    regex: /(\[.*?\])([ \t]*)(<warning>)(.+)(.?)/,
    token: ["tag", "", "comment", "comment", "hr"],
    sol: !0
    // next: "warning",
  }
];
_.defineSimpleMode("fclog", {
  start: [
    ...C,
    {
      regex: /.*/,
      token: "hr"
    }
  ],
  error: [
    ...C,
    {
      regex: /.*/,
      token: "error.strong"
    }
  ],
  info: [
    ...C,
    {
      regex: /.*/,
      token: "bracket"
    }
  ],
  warning: [
    ...C,
    {
      regex: /.*\[/,
      token: "comment"
    }
  ]
});
_.defineSimpleMode("log", {
  start: [
    {
      regex: /^[=]+[^=]*[=]+/,
      token: "strong"
    },
    {
      regex: /([^\w])([A-Z][\w]*)/,
      token: ["", "string"]
    },
    {
      regex: /(^[A-Z][\w]*)/,
      token: "string"
    }
    // {
    //     regex: /([^\d])([0-9]+)/,
    //     token: [null, 'comment']
    // },
    // {
    //     regex: /(^[0-9]+)/,
    //     token: 'comment'
    // }
  ]
});
const he = M({
  name: "CodemirrorFclog",
  props: {
    value: {
      type: String,
      default: ""
    },
    name: {
      type: String,
      default: `cm-textarea-${+/* @__PURE__ */ new Date()}`
    },
    options: {
      type: Object,
      default: () => ({})
    },
    cminstance: {
      type: Object,
      default: () => ({})
    },
    placeholder: {
      type: String,
      default: ""
    }
  },
  emits: ["update:cminstance", "ready"],
  setup(e, { emit: n }) {
    const r = v(), t = v(null), o = (l = e.cminstance) => {
      l.getAllMarks().forEach((c) => c.clear());
      const u = l.getValue(), d = [].concat(ge(u)).concat(fe(u));
      for (let c = 0; c < d.length; c++) {
        const p = d[c];
        l.markText(
          l.posFromIndex(p.start),
          l.posFromIndex(p.end),
          { replacedWith: p.node }
        );
      }
    }, s = () => {
      var l;
      t.value = j(_.fromTextArea(r.value, e.options)), n("update:cminstance", w(t)), (l = t.value) == null || l.on("change", o);
    };
    return x(
      () => e.cminstance,
      (l) => {
        var m;
        l && (o(e.cminstance), (m = e.cminstance) == null || m.setValue(e.value), n("ready", t));
      },
      { deep: !0, immediate: !0 }
    ), L(() => {
      s();
    }), {
      initialize: s,
      textarea: r
    };
  }
}), ve = ["name", "placeholder"];
function ye(e, n, r, t, o, s) {
  return b(), S("textarea", {
    ref: "textarea",
    name: e.$props.name,
    placeholder: e.$props.placeholder
  }, null, 8, ve);
}
const we = /* @__PURE__ */ I(he, [["render", ye]]), z = {
  "update:value": () => !0,
  change: (e, n) => ({ value: e, cm: n }),
  input: () => !0,
  ready: (e) => e
}, ke = [
  "changes",
  "scroll",
  "beforeChange",
  "cursorActivity",
  "keyHandled",
  "inputRead",
  "electricInput",
  "beforeSelectionChange",
  "viewportChange",
  "swapDoc",
  "gutterClick",
  "gutterContextMenu",
  "focus",
  "blur",
  "refresh",
  "optionChange",
  "scrollCursorIntoView",
  "update"
], $e = () => {
  const e = {};
  return ke.forEach((n) => {
    e[n] = (...r) => r;
  }), e;
}, xe = { ...z, ...$e() }, O = {
  mode: "text",
  // Language mode
  theme: "default",
  // Theme
  lineNumbers: !0,
  // Display line number
  smartIndent: !0,
  // Intelligent indentation
  indentUnit: 2,
  styleActiveLine: !0
};
function _e(e) {
  Promise.resolve().then(() => {
    const n = e.getScrollInfo();
    e.scrollTo(n.left, n.height);
  });
}
const be = ({
  props: e,
  cminstance: n,
  emit: r,
  internalInstance: t,
  content: o
}) => {
  const s = T(
    () => {
      var u;
      return e.merge ? (u = w(n)) == null ? void 0 : u.editor() : w(n);
    }
  ), l = () => {
    const u = [];
    return Object.keys(t == null ? void 0 : t.vnode.props).forEach((d) => {
      if (d.startsWith("on")) {
        const c = d.replace(d[2], d[2].toLowerCase()).slice(2);
        !z[c] && u.push(c);
      }
    }), u;
  };
  return {
    listenerEvents: () => {
      s.value.on("change", (c) => {
        const p = c.getValue();
        p === o.value && p !== "" || (o.value = p, r("update:value", o.value || ""), r("input", o.value || " "), Promise.resolve().then(() => {
          r("change", o.value, c);
        }), e.keepCursorInEnd && _e(c));
      });
      const u = {};
      l().filter((c) => !u[c] && (u[c] = !0)).forEach((c) => {
        s.value.on(c, (...p) => {
          r(c, ...p);
        });
      });
    }
  };
};
function Ce({ props: e, cminstance: n, presetRef: r }) {
  const t = v(null), o = v(null), s = T(
    () => {
      var i;
      return e.merge ? (i = w(n)) == null ? void 0 : i.editor() : w(n);
    }
  ), l = () => {
    q(() => {
      var i;
      (i = s.value) == null || i.refresh();
    });
  }, m = (i = e.width, f = e.height) => {
    var y;
    t.value = String(i).replace("px", ""), o.value = String(f).replace("px", "");
    const k = o.value;
    (y = s.value) == null || y.setSize(t.value, k);
  }, u = () => {
    var f;
    const i = (f = s.value) == null ? void 0 : f.getWrapperElement();
    i == null || i.remove();
  }, d = () => {
    var f, k, y;
    const i = (f = s.value) == null ? void 0 : f.getDoc().getHistory();
    (k = r.value) == null || k.initialize(), u(), (y = s.value) == null || y.getDoc().setHistory(i);
  }, c = () => {
    const i = document.querySelector(".CodeMirror-gutters");
    return (i == null ? void 0 : i.style.left.replace("px", "")) !== "0";
  };
  return {
    reload: d,
    refresh: l,
    resize: m,
    destroy: u,
    containerHeight: o,
    reviseStyle: () => {
      if (l(), !c())
        return;
      const i = setInterval(() => {
        c() ? l() : clearInterval(i);
      }, 60), f = setTimeout(() => {
        clearInterval(i), clearTimeout(f);
      }, 400);
    }
  };
}
const H = /* @__PURE__ */ M({
  __name: "index",
  props: {
    value: {
      type: String,
      default: ""
    },
    options: {
      type: Object,
      default: () => O
    },
    globalOptions: {
      type: Object,
      default: () => O
    },
    placeholder: {
      type: String,
      default: ""
    },
    border: {
      type: Boolean,
      default: !1
    },
    width: {
      type: [String, Number],
      default: null
    },
    height: {
      type: [String, Number],
      default: null
    },
    originalStyle: {
      type: Boolean,
      default: !1
    },
    keepCursorInEnd: {
      type: Boolean,
      default: !1
    },
    merge: {
      type: Boolean,
      default: !1
    },
    name: {
      type: String,
      default: ""
    },
    marker: {
      type: Function,
      default: () => null
    },
    unseenLines: {
      type: Array,
      default: () => []
    }
  },
  emits: xe,
  setup(e, { expose: n, emit: r }) {
    var D, N, V;
    typeof Object.assign != "function" && Object.defineProperty(Object, "assign", {
      value(a) {
        if (a == null)
          throw new TypeError("Cannot convert undefined or null to object");
        const g = Object(a);
        for (let h = 1; h < arguments.length; h++) {
          const $ = arguments[h];
          if ($ != null)
            for (const E in $)
              Object.prototype.hasOwnProperty.call($, E) && (g[E] = $[E]);
        }
        return g;
      },
      writable: !0,
      configurable: !0
    });
    const t = e, o = r, s = v(null), l = v(""), m = K(F), u = v({
      foldGutter: !0,
      ...O,
      ...t.globalOptions,
      ...t.options,
      gutters: [
        .../* @__PURE__ */ new Set([
          "CodeMirror-linenumbers",
          "CodeMirror-foldgutter",
          ...((D = t.options) == null ? void 0 : D.gutters) || []
        ])
      ]
    }), d = Q(), c = t.name || ((V = (N = d == null ? void 0 : d.parent) == null ? void 0 : N.type) == null ? void 0 : V.name) || void 0, p = v(null), i = T(
      () => {
        var a;
        return t.merge ? (a = w(s)) == null ? void 0 : a.editor() : w(s);
      }
    ), { refresh: f, resize: k, destroy: y, containerHeight: P, reviseStyle: U } = Ce({
      props: t,
      cminstance: s,
      presetRef: p
    }), { listenerEvents: W } = be({
      props: t,
      cminstance: s,
      emit: o,
      internalInstance: d,
      content: l
    }), A = () => {
      t.unseenLines !== void 0 && t.marker !== void 0 && t.unseenLines.forEach((a) => {
        var h, $;
        const g = (h = s.value) == null ? void 0 : h.lineInfo(a);
        ($ = s.value) == null || $.setGutterMarker(
          a,
          "breakpoints",
          g != null && g.gutterMarkers ? null : t.marker()
        );
      });
    }, G = (a) => {
      var h, $;
      const g = (h = s.value) == null ? void 0 : h.getValue();
      a !== g && (($ = s.value) == null || $.setValue(a), l.value = a, U()), A();
    }, J = () => {
      W(), A(), k(t.width, t.height), o("ready", s.value), x(
        [() => t.width, () => t.height],
        ([a, g]) => {
          k(a, g);
        },
        { deep: !0 }
      );
    }, Z = () => {
      if (t.options.mode === "fclog" || t.options.mode === "log") {
        m.value = we;
        return;
      }
      if (t.merge) {
        m.value = de;
        return;
      }
      m.value = F;
    };
    return x(
      () => t.options,
      (a) => {
        var g;
        for (const h in t.options)
          (g = i.value) == null || g.setOption(
            h,
            w(a[h])
          );
      },
      { deep: !0 }
    ), x(
      () => t.value,
      (a) => {
        G(a);
      }
    ), x(() => t.merge, Z, { immediate: !0 }), X(() => {
      y();
    }), n({
      cminstance: s,
      resize: k,
      refresh: f,
      destroy: y
    }), (a, g) => (b(), S("div", {
      class: Y(["codemirror-container", {
        merge: a.$props.merge,
        bordered: a.$props.border || a.$props.merge && !t.originalStyle,
        "width-auto": !a.$props.width || a.$props.width == "100%",
        "height-auto": !a.$props.height || a.$props.height == "100%",
        "original-style": t.originalStyle
      }]),
      style: ee({
        height: w(P) + "px"
      })
    }, [
      (b(), te(ne(m.value), oe({
        ref_key: "presetRef",
        ref: p,
        cminstance: s.value,
        "onUpdate:cminstance": g[0] || (g[0] = (h) => s.value = h),
        style: { height: "100%" }
      }, {
        ...a.$props,
        ...a.$attrs,
        options: u.value,
        name: w(c),
        content: l.value
      }, { onReady: J }), null, 16, ["cminstance"]))
    ], 6));
  }
}), B = (e, n) => (n && n.options && (H.props.globalOptions.default = () => n.options), e.component((n == null ? void 0 : n.componentName) || "Codemirror", H), e), Be = window.CodeMirror || _, Pe = B, Ue = B;
function styleInject(css,ref){if(ref===void 0){ref={}}var insertAt=ref.insertAt;if(!css||typeof document==="undefined"){return}var head=document.head||document.getElementsByTagName("head")[0];var style=document.createElement("style");style.type="text/css";if(insertAt==="top"){if(head.firstChild){head.insertBefore(style,head.firstChild)}else{head.appendChild(style)}}else{head.appendChild(style)}if(style.styleSheet){style.styleSheet.cssText=css}else{style.appendChild(document.createTextNode(css))}};styleInject(`.codemirror-container {
  position: relative;
  display: inline-block;
  height: 100%;
  width: fit-content;
  font-size: 13px;
  overflow: hidden;
}
.codemirror-container.bordered {
    border: 1px solid #aaaaaa;
}
.codemirror-container.width-auto {
  width: 100%;
}
.codemirror-container.height-auto {
  height: 100%;
}
.codemirror-container.height-auto .CodeMirror,
.codemirror-container.height-auto .cm-s-default {
  height: 100% !important;
}
.codemirror-container .editor_custom_link {
  cursor: pointer;
  color: #1474f1;
  text-decoration: underline;
}
.codemirror-container .editor_custom_link:hover {
  color: #04b4fa;
}
.codemirror-container:not(.original-style) .CodeMirror-lines .CodeMirror-placeholder.CodeMirror-line-like {
  color: #666;
}
.codemirror-container:not(.original-style) .CodeMirror,
.codemirror-container:not(.original-style) .CodeMirror-merge-pane {
  height: 100%;
  font-family: consolas !important;
}
.codemirror-container:not(.original-style) .CodeMirror-merge,
.codemirror-container:not(.original-style) .CodeMirror-merge-right .CodeMirror {
  height: 100%;
  border: none !important;
}
.codemirror-container:not(.original-style) .c-editor--log__error {
  color: #bb0606;
  font-weight: bold;
}
.codemirror-container:not(.original-style) .c-editor--log__info {
  color: #333333;
  font-weight: bold;
}
.codemirror-container:not(.original-style) .c-editor--log__warning {
  color: #ee9900;
}
.codemirror-container:not(.original-style) .c-editor--log__success {
  color: #669600;
}
.codemirror-container:not(.original-style) .cm-header,
.codemirror-container:not(.original-style) .cm-strong {
  font-weight: bold;
}
`);
export {
  Be as CodeMirror,
  Pe as GlobalCmComponent,
  Ue as InstallCodemirro,
  H as VueCodemirror,
  Fe as createLinkMark,
  Re as createLog,
  He as createLogMark,
  ze as createTitle,
  H as default,
  ge as getLinkMarks,
  me as getLocalTime,
  fe as getLogMark,
  pe as logErrorType
};
